<?php

/* -------------------------------------------------------------------------------------------- *
*							CREATION DE LA  PAGE D'ADMINISTRATION								*
* --------------------------------------------------------------------------------------------- */

function jbm_dropdown_pages($select) {
	
	$html = '<select id="cookie_url_policy" name="cookie_url_policy">';
	$pages = get_pages();
	
	foreach($pages as $page) {
		if ($select == $page->ID) {
			$html .= '<option value="'.$page->ID.'" selected>'.$page->post_title.'</option>';
		} else {
			$html .= '<option value="'.$page->ID.'">'.$page->post_title.'</option>';
		} 
	}
	
	$html .= '</select>';
	
	return $html;
}

function jbm_cookie_page_markup() {
	// Retrieve plugin configuration options from database
	//Récupérer les options de configuration du plugin à partir de la base de données
	$options = cookie_get_options();
	echo '
	<div id="cookie-general" class="wrap">
	<h2>JBM COOKIE CONSENT - 2020</h2><br />';
if(isset($_GET['result'])) {
	if($_GET['result'] == '1') {
	echo '<div id="message" class="updated"><p><strong>Settings saved</strong></p></div>';
}
else {
	echo '<div id="message" class="error"><p><strong>Settings failed</strong></p></div>';	
}
}

	// ****************************************************
	// Création du formulaire d'administration
	// enqueue_style

	echo '<link href="'.esc_url( plugins_url( 'cookie_consent.css', __FILE__ ) ).'"" rel="stylesheet" type="text/css">';
	echo '
	<div class="groupe-cookie">
	<img class="image" src="'.esc_url( plugins_url( 'img/cookies-maison.png', __FILE__ ) ).'" width="750" height="562" alt="Cookie Maison"/>
	<p>Le plugin JBM Cookie Consent vous aidera à rendre votre site Web conforme au RGPD. Le règlement général sur la protection des données (RGPD) et la directive ePrivacy (ePR) affectent la manière dont vous, en tant que propriétaire d\'un site web, pouvez utiliser les cookies et le suivi en ligne des visiteurs de l\'UE. Il incombe aux propriétaires et aux opérateurs de sites web de s\'assurer que les données personnelles sont collectées et traitées légalement.
	<form method="post" action="admin-post.php">

	 <input type="hidden" name="action"
		value="save_cookie_options" />

	 <!-- Adding security through hidden referrer field -->
	 '.wp_nonce_field( 'cookie_consent', 'save_options' ).'
	 
	 <hr>
	 <table width="100%" border="0" cellspacing="0" cellpadding="5">
	  <tbody>
		<tr>
		  <td><label for="cookie_actived">Activer la bannière des cookies : </label></td>
		  <td><input id="cookie_actived" name="cookie_actived" type="checkbox"';
			if ($options['cookie_actived'] == 'on') {
				echo "checked";
			}
		  echo '>
		  </td>
		</tr>
		<tr>
		  <td><label for="cookie_">Activer le bouton "Refuser" : </label></td>
		  <td><input id="cookie_refuse" name="cookie_refuse" type="checkbox"';
			if ($options['cookie_refuse'] == 'on') {
				echo "checked>&nbsp;<i>(controle du refut par une varible de session : cookie = yes/no)</i>";
			} else {
				echo ">";
			}
		  echo '</td>
		</tr>		
		<tr>
		  <td><label for="cookie_text">Texte la bannière :</label></td>
		  <td><textarea id="cookie_text" name="cookie_text">'.esc_html( $options['cookie_text'] ).'</textarea></td>
		</tr>
		<tr>
		<tr>
		  <td><label for="cookie_url_policy">Politique de confidentialité   :</label></td>
		  <td>'.jbm_dropdown_pages($options['cookie_url_policy']).'</td>
		</tr>	   
	  </tbody>
	</table>
	<hr>
	 <table width="100%" border="0" cellspacing="0" cellpadding="5">
	  <tbody>
		<tr>
		  <td><label for="cookie_color_text">Couleur de texte :</label></td>
		  <td><input id="cookie_color_text" type="color" name="cookie_color_text" value="'.esc_html( $options['cookie_color_text'] ).'"/></td>
		</tr>
		<tr>
		  <td><label for="cookie_color_bground">Couleur d\'arrière-plan :</label></td>
		  <td><input id="cookie_color_bground" name="cookie_color_bground" type="color" value="'.esc_html( $options['cookie_color_bground'] ).'"></td>
		</tr>
		<tr>
		  <td><label for="cookie_color_button">Couleur des boutons :</label></td>
		  <td><input id="cookie_color_button" name="cookie_color_button" type="color" value="'.esc_html( $options['cookie_color_button'] ).'"></td>
		</tr>
		<tr>
		  <td><label for="cookie_color_hover">Couleur de survol :</label></td>
		  <td><input id="cookie_color_hover" name="cookie_color_hover" type="color" value="'.esc_html( $options['cookie_color_hover'] ).'"></td>
		</tr>
		<tr>
		  <td><label for="cookie_form_border">Bordure :</label></td>
		  <td><select id="cookie_form_border" name="cookie_form_border">
		  	<option ';
			if ($options['cookie_form_border'] == 'border1') { echo "selected='selected'"; }
		echo ' value="border1">Arrondie</option>
			<option ';
			if ($options['cookie_form_border'] == 'border2') { echo "selected='selected'"; }
		echo' value="border2">Carré</option>
		  </select>
		</tr>
		<tr>
		  <td><label for="cookie_form_border">Mise en forme :</label></td>
		  <td><select id="cookie_form_type" name="cookie_form_type">
		  	<option ';
			if ($options['cookie_form_type'] == 'type1') { echo "selected='selected'"; }
		echo ' value="type1">Cadre centrer</option>
			<option ';
			if ($options['cookie_form_type'] == 'type2') { echo "selected='selected'"; }
		echo' value="type2">Bannière</option>
		  </select>
		</tr>		
	  </tbody>
	</table>
	<hr>
	<p><input type="submit" value="Enregistrer les modifications" class="button-primary"/></p>
	</form>
	<p class="copy">
	<a href="https://www.jb-martinez.net" target="_blanck">
	Jean-Bernard MARTINEZ &copy; jb-martinez.net</a></p>
	</div>';
	
	// ****************************************************
 }


function cookie_get_options() {	

	$options = get_option( 'cookie_options', array() );
	
	$new_options['cookie_actived'] = '';
	
	$new_options['cookie_refuse'] = '';
	
    $new_options['cookie_text'] = 'Ce site Web utilise des cookies pour vous garantir la meilleure expérience sur notre site Web.';
	
	$new_options['cookie_url_policy'] = 3;
	
	$new_options['cookie_color_text'] = '#000000';
	
	$new_options['cookie_color_bground'] = '#ffffff';

	$new_options['cookie_color_button'] = '#cccccc';
	
	$new_options['cookie_color_hover'] = '#cd2653';
	
	$new_options['cookie_form_border'] = 'border2';
	
	$new_options['cookie_form_type'] = 'type1';

	
    $merged_options = wp_parse_args( $options, $new_options ); 
    $compare_options = array_diff_key( $new_options, $options ); 
	
    if ( empty( $options ) || !empty( $compare_options ) ) {
        update_option( 'cookie_options', $merged_options );
    }
	
    return $merged_options;
}




/* -------------------------------------------------------------------------------------------- *
*				ENREGISTREMENT DES DONNEES ET RETOURE SUR LA PAGE D'ADMINISTRATION				*
* --------------------------------------------------------------------------------------------- */ 

add_action( 'admin_init', 'cookie_admin_init' );

function cookie_admin_init() {
	//the add_action must begin by admin_post_ following by the name of the hidden field named "action".
	//By this way, admin-post.php make a do-action.
	add_action( 'admin_post_save_cookie_options',
		 'process_cookie_options' );
}

function process_cookie_options() {

	// Check that user has proper security level

	if ( !current_user_can( 'manage_options' ) )
		wp_die( 'Not allowed' );
        
	// Check that nonce field created in configuration form
	// is present

	check_admin_referer( 'cookie_consent', 'save_options' );

	// Retrieve original plugin options array
	$options = cookie_get_options();

	// Ckeck all form fields and store their values
	// in the options array

		$options = array();
		$result = '1';
	
		if ( isset( $_POST['cookie_actived'] ) && !empty( $_POST['cookie_actived'] )  
			&& ($_POST['cookie_actived'] == 1 || $_POST['cookie_actived'] == 0) ) {
			$options['cookie_actived'] = $_POST['cookie_actived'];
		}
		if ( isset( $_POST['cookie_refuse'] ) && !empty( $_POST['cookie_refuse'] )  
			&& ($_POST['cookie_refuse'] == 1 || $_POST['cookie_refuse'] == 0) ) {
			$options['cookie_refuse'] = $_POST['cookie_refuse'];
		}
		if ( isset( $_POST['cookie_text'] ) && !empty( $_POST['cookie_text']) ) {
			$options['cookie_text'] = strip_tags($_POST['cookie_text']);
		} else {
			$result = '0';
		}
		if ( isset( $_POST['cookie_url_policy'] ) && !empty( $_POST['cookie_url_policy'] ) ) {
			$options['cookie_url_policy'] = $_POST['cookie_url_policy'];
		} else {
			$result = '0';
		}
		if (isset( $_POST['cookie_color_text'] ) && !empty( $_POST['cookie_color_text'] ) ) {
			$options['cookie_color_text'] = sanitize_hex_color( $_POST['cookie_color_text'] );
		}
		if (isset( $_POST['cookie_color_bground'] ) && !empty( $_POST['cookie_color_bground'] ) ) {
			$options['cookie_color_bground'] = sanitize_hex_color( $_POST['cookie_color_bground'] );
		}
		if (isset( $_POST['cookie_color_button'] ) && !empty( $_POST['cookie_color_button'] ) ) {
			$options['cookie_color_button'] = sanitize_hex_color( $_POST['cookie_color_button'] );
		}
		if (isset( $_POST['cookie_color_hover'] ) && !empty( $_POST['cookie_color_hover'] ) ) {
			$options['cookie_color_hover'] = sanitize_hex_color( $_POST['cookie_color_hover'] );
		}
		if (isset( $_POST['cookie_form_border'] ) && !empty( $_POST['cookie_form_border'] )  ){
			$options['cookie_form_border'] = $_POST['cookie_form_border'];
		}
	
		if (isset( $_POST['cookie_form_type'] ) && !empty( $_POST['cookie_form_type'] )  ){
			$options['cookie_form_type'] = $_POST['cookie_form_type'];
		}	


	// Store updated options array to database
	if($result == 1) {
		update_option( 'cookie_options', $options );
	}

	// Redirect the page to the configuration form that was
	// processed

	wp_redirect( add_query_arg( array('result' => $result, 'page' => 'cookie-admin-home'), admin_url( 'admin.php' ) ) );
									   
	exit; //*** mandatory, don't forget to exit at the end of the function. ****
}
?>