<?php

/* -------------------------------------------------------------------------------------------- *
*							AJOUT AU DOM A LA FIN DU FOOTER										*
* --------------------------------------------------------------------------------------------- */
// Hook the 'wp_footer' action hook, add the function named 'jbm_mfp_Add_Text' to it
// Ajouter au DOM à la fin du footer grace à la fontion 'wp_footer'


	$options = cookie_get_options();

	if(!isset($_COOKIE['JBM_test_cookie']) && $options['cookie_actived'] == true ) { // si cookie
		add_action("wp_footer", "jbm_mfp_Add_Text");
	}


// Define 'mfp_Add_Text'
function jbm_mfp_Add_Text()
{
	
	global $options;
	
	$gdrp_cookie =  "<div id='cookie-concent'>";
	$gdrp_cookie .= "<p>".esc_html( $options['cookie_text'] )."&nbsp;";
	$gdrp_cookie .= "<a class='voir_suite' href='".get_permalink( $options['cookie_url_policy'] )."'>En savoir plus</a></p>";
	$gdrp_cookie .= "<p>";
	if ($options['cookie_refuse'] == 'on') {
	$gdrp_cookie .= "<a class='bouton' href='javascript:cookie_accept(\"false\");'>REFUSER</a><a class='bouton' href='javascript:cookie_accept(\"true\");'>Accepter</a></p>";
	} else {
	$gdrp_cookie .= "<a class='bouton' href='javascript:cookie_accept(\"true\");'>Ok</a></p>";		
	}
	
	$gdrp_cookie .= "</div>
	<style>
	#cookie-concent { 	
	position: fixed;
	z-index: 1000;
	width: calc(100% - 2rem);
	color: ".esc_html( $options['cookie_color_text'] ).";
	background-color: ".esc_html( $options['cookie_color_bground'] ).";
	padding: 1rem;";
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type1' ) {
	$gdrp_cookie .= "border: 1px solid ".esc_html( $options['cookie_color_text'] ).";
	margin-left: 1rem;bottom: 2rem;";	
	}
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type2' ) {
	$gdrp_cookie .= "border: 0;
	border-top: 1px solid ".esc_html( $options['cookie_color_text'] ).";
	bottom: 0;";	
	}	
	
	if ($options['cookie_form_border'] == "border1" && $options['cookie_form_type'] == 'type1') {
		$gdrp_cookie .= "border-radius: 20px;";
	}
	if ($options['cookie_form_border'] == "border1" && $options['cookie_form_type'] == 'type2') {
		$gdrp_cookie .= "border-radius: 0;";
	}	
	
	if ($options['cookie_form_border'] == "border2") {
		$gdrp_cookie .= "border-radius: 0;";
	}
	
	$gdrp_cookie .= "	
	}
	#cookie-concent p {";
	if ($options['cookie_form_type'] == 'type1') {
	$gdrp_cookie .= "text-align: justify;";
	}
	if ($options['cookie_form_type'] == 'type2') {
	$gdrp_cookie .= "text-align: center";
	}	
	$gdrp_cookie .= "}
	
	#cookie-concent p:last-of-type {
	text-align: center;
	}
	#cookie-concent p a {
		color: ".esc_html( $options['cookie_color_text'] ).";
		text-decoration: underline;
	}
	#cookie-concent p a:hover {
		color: ".esc_html( $options['cookie_color_hover'] ).";
		text-decoration: underline overline;
	}	
	#cookie-concent .bouton {
	position: relative;
	display: inline-block;
	width: 48%;
	height: 30px;
	margin-right: 1rem;
	margin-bottom: 0.2rem;
	text-align: center;
	text-decoration:none!important;
	color: ".esc_html( $options['cookie_color_text'] ).";
	background-color: ".esc_html( $options['cookie_color_button'] ).";
	padding: 0 1rem;
	border: 1px solid ".esc_html( $options['cookie_color_button'] ).";
	border-radius: 20px;
	text-transform: uppercase;";
	
	if ($options['cookie_form_border'] == "border1") {
		$gdrp_cookie .= "border-radius: 20px;";
	}
	if ($options['cookie_form_border'] == "border2") {
		$gdrp_cookie .= "border-radius: 0;";
	}	

	$gdrp_cookie .= "}
	#cookie-concent .bouton:hover {
	color: ".esc_html( $options['cookie_color_bground'] ).";
	background-color: ".esc_html( $options['cookie_color_hover'] ).";
	border: 1px solid ".esc_html( $options['cookie_color_hover'] ).";
	}
	@media (min-width: 350px) {
	#cookie-concent { 
	width: calc(100% - 2rem);
	margin-left: 1rem;
	}
	}	
	@media (min-width: 992px) {";
	
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type1' ) {
	$gdrp_cookie .= "#cookie-concent {
	width: 40%;
	margin-left: calc(50% - 20%);
	}";
	}
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type2' ) {
	$gdrp_cookie .= "#cookie-concent {
	width: 100%;
	margin-left: 0;
	bottom: 0;
	border: none;
	border-top: 1px solid ".esc_html( $options['cookie_color_text'] ).";
	}
	#cookie-concent p:nth-child(2) {
		margin-bottom: 0;	
	}";
	}	
	
	$gdrp_cookie .= "#cookie-concent .bouton {
	width: 150px;
	}
	}
	@media (min-width: 1200px) {";
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type1' ) {
	$gdrp_cookie .= "#cookie-concent { 
	width: 30%;
	margin-left: calc(50% - 15%);
	}";
	}
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type2' ) {
	$gdrp_cookie .= "#cookie-concent { 
	width: 100%;
	margin-left: 0;
	}";
	}	
	$gdrp_cookie .= "}	
	@media (min-width: 1800px) {
	#cookie-concent {"; 
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type1' ) {
	$gdrp_cookie .= "width: 20%;
	margin-left: calc(50% - 10%);";
	}
	if(!isset($_COOKIE['cookie_form_type']) && $options['cookie_form_type'] == 'type2' ) {
	$gdrp_cookie .= "width: 100%;
	margin-left: 0;";
	}	
	$gdrp_cookie .= "}
	}
	";
	$gdrp_cookie .= "</style>";	
	$gdrp_cookie .= "<script>
	function cookie_accept(value) {
		var d = new Date();
		d.setTime(d.getTime() + (366*24*60*60*1000));
		var expires = 'expires='+ d.toUTCString();
		if (value == 'false') {
		document.cookie = 'JBM_test_cookie=WP+Cookie+no;' + expires + ';path=/';
		document.getElementById('cookie-concent').style.display = 'none';		
		} else {
		document.cookie = 'JBM_test_cookie=WP+Cookie+check;' + expires + ';path=/';
		document.getElementById('cookie-concent').style.display = 'none';		
		}
	}
	</script>";


	echo $gdrp_cookie;
}
