<?php
/**
 * @package JBM Cookie Consent
 * @version 1.0.0
 */
/*
Plugin Name: JBM Cookie Consent
Plugin URI: https://jb-martinez.net/plugins/jbm-cookie-consent/
Description: Le plugin JBM Cookie Consent vous aidera à rendre votre site Web conforme au RGPD. Le règlement général sur la protection des données (RGPD) et la directive ePrivacy (ePR) affectent la manière dont vous, en tant que propriétaire d'un site web, pouvez utiliser les cookies et le suivi en ligne des visiteurs de l'UE. Il incombe aux propriétaires et aux opérateurs de sites web de s'assurer que les données personnelles sont collectées et traitées légalement.
Author: Jean-Bernard MARTINEZ
Version: 1.0.0
Author URI: https://jb-martinez.net
*/

// ****************************************************
// Ajout de lien dans la présentation de l'extention
function jbm_baw_settings_action_links( $links, $file ) {
    
    // lien vers les widgets
    //$mylink = '<a href="' . admin_url( 'widgets.php' ) . '">' . __( 'Widgets' ) . '</a>'; 
    //array_push( $links, $mylink );
    
     // liens vers les articles
    //$links[] = '<a href="' . admin_url( 'edit.php' ) . '">' . __( 'Posts' ) . '</a>';
    
    // lien vers la page de config de ce plugin
    array_unshift( $links, '<a href="' . admin_url( 'admin.php?page=cookie-admin-home' ) . '">' . __( 'Settings' ) . '</a>' );

    return $links;
	
}
add_filter( 'plugin_action_links_'.plugin_basename( __FILE__ ), 'jbm_baw_settings_action_links', 10, 2 );
// ****************************************************


// ****************************************************
// Ajout dans le menu d'administration
// In plugin main file
add_action( 'admin_menu', 'jbm_cookie_menu_items' );
/**
 * Registers our new menu item
 */
function jbm_cookie_menu_items() {
    // Create a top-level menu item.
    $hookname = add_menu_page(
        __( 'JBM Cookie consent - JBM 2020', 'example' ),  // Page title
        __( 'JBM Cookie', 'example' ),  // Menu title
        'manage_options',                     // Capabilities
        'cookie-admin-home',              // Slug
        'jbm_cookie_page_markup',       // Display callback
        'dashicons-buddicons-community',                   // Icon
        75                                    // Priority/position. Just after 'Plugins'
    );
	// ****************************************************

}


require("admin/cookie_admin_home.php"); // Gestion de la page d'administration en back-end 
require("admin/cookie_wp_footer.php"); // Intégration dans le footer en front-end